# -*- coding:Utf-8 -*-
#!/usr/bin/python

# \copyleft Denis LE FUR \copyright
# This work may be distributed and/or mofified under the conditions
# or the LaTeX Project Public Licence, either v1.3 or (at your option)
# any later version. The latest version is in
#   http://www.latex-project.org/lppl/
# This work consists of the files courbesemilog.py.


import pygtk
pygtk.require("2.0")
import gtk  

import os
import sys
import platform

if platform.system()=="Linux" :
    sys.path.append("../SystemeLinux/")
else :
    sys.path.append("../SystemeWindows/")
from pro_sortie import *


sys.path.append("../Divers/")
from pro_divers import *
from textelibre import *
from pointlibre import *
sys.path.append("../Supplements/Pro-courbes/")
from supp_courbesemilog import *

from fonctionsemilog import *



class Courbesemilog:



    #-------------------------------------------------------------
    # Initialisations, création de la fenêtre principale
    #-------------------------------------------------------------
    def __init__(self):
        interface = gtk.Builder()
        interface.add_from_file('courbesemilog.glade')
        self.initialisation=True
        self.radiobuttonMetapost = interface.get_object("radiobuttonMetapost")
        self.radiobuttonAsymptote = interface.get_object("radiobuttonAsymptote")
        self.entryXmin = interface.get_object("entryXmin")
        self.entryXmax = interface.get_object("entryXmax")
        self.entryYmin = interface.get_object("entryYmin")
        self.entryYmax = interface.get_object("entryYmax")
        self.entryUx = interface.get_object("entryUx")
        self.entryHauteur = interface.get_object("entryHauteur")
        self.buttonCompiler = interface.get_object("buttonCompiler")
        self.progressbar = interface.get_object("progressbar")
        self.buttonCodeGraphique = interface.get_object("buttonCodeGraphique")
        self.buttonPdf = interface.get_object("buttonPdf")
        self.textviewCodeProfessor = interface.get_object("textviewCodeProfessor")
        self.textviewSupp = interface.get_object("textviewSupp")
        self.labelEntete = interface.get_object("labelEntete")
        self.checkbuttonTitreGauche = interface.get_object("checkbuttonTitreGauche")
        self.checkbuttonTitreCentre = interface.get_object("checkbuttonTitreCentre")
        self.checkbuttonTitreDroite = interface.get_object("checkbuttonTitreDroite")
        self.checkbuttonF2 = interface.get_object("checkbuttonF2")
        self.checkbuttonF3 = interface.get_object("checkbuttonF3")
        self.checkbuttonF4 = interface.get_object("checkbuttonF4")
        self.checkbuttonPointLibre = interface.get_object("checkbuttonPointLibre")
        self.checkbuttonTexteLibre = interface.get_object("checkbuttonTexteLibre")
        self.entryTitreGauche = interface.get_object("entryTitreGauche")
        self.entryTitreCentre = interface.get_object("entryTitreCentre")
        self.entryTitreDroite = interface.get_object("entryTitreDroite")    


        
        #Indique si la compilation est lancée
        self.Etat_Compilation=False
        
        #fenêtre textlibre
        self.TL=Textelibre(self)
        self.TL.windowTL.set_title("Textes supplémentaires")
        self.TL.windowTL.hide()
        
        #fenêtre pointlibre
        self.PL=Pointlibre(self)
        self.PL.windowPL.set_title("Points supplémentaires")
        self.PL.windowPL.hide()
        
        
        #fenêtre fonctions
        self.F1=Fonction(self)
        self.F1.windowF.set_title("Fonction 1")
        self.F1.Numero="1"
        self.F1.checkbuttonActiver.set_active(True)
        self.F1.checkbuttonActiver.hide()
        
        self.F2=Fonction(self)
        self.F2.Numero="2"
        self.F2.windowF.set_title("Fonction 2")
        self.F2.windowF.hide()
        
        self.F3=Fonction(self)
        self.F3.Numero="3"
        self.F3.windowF.set_title("Fonction 3")
        self.F3.windowF.hide()
        
        self.F4=Fonction(self)
        self.F4.Numero="4"
        self.F4.windowF.set_title("Fonction 4")
        self.F4.windowF.hide()

        
        interface.connect_signals(self)
        self.maj_codeprofessor()
        maj_codesupp(self)
        
        self.textviewCodeProfessor.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse(couleurfond))
        self.textviewSupp.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse(couleurfond))
        
        #désactivation

        self.entryTitreGauche.set_sensitive(False)
        self.entryTitreCentre.set_sensitive(False)
        self.entryTitreDroite.set_sensitive(False)
        
        self.entryUx.set_sensitive(False)

        
        
        self.initialisation=False


    #-------------------------------------------------------------  
    # Fin de l'application  
    #-------------------------------------------------------------
    def on_windowCourbesemilog_destroy(self, widget):
        gtk.main_quit()

    #-------------------------------------------------------------
    # Met à jour le code à insérer
    #-------------------------------------------------------------  
    def maj_codeprofessor(self):
        text_view=self.textviewCodeProfessor
        Texte_Code="\\begin{pro-courbesemilog}{1}\n"
        Texte_Code=Texte_Code+"[\n"
        Texte_Code=Texte_Code+self.F1.Texte_Fonction
        if self.F2.checkbuttonActiver.get_active()==True:
            Texte_Code=Texte_Code+",\n"
            Texte_Code=Texte_Code+self.F2.Texte_Fonction
        if self.F3.checkbuttonActiver.get_active()==True:
            Texte_Code=Texte_Code+",\n"
            Texte_Code=Texte_Code+self.F3.Texte_Fonction
        if self.F4.checkbuttonActiver.get_active()==True:
            Texte_Code=Texte_Code+",\n"
            Texte_Code=Texte_Code+self.F4.Texte_Fonction    
        Texte_Code=Texte_Code+"\n"  
        Texte_Code=Texte_Code+"],\n"
        Xmin=self.entryXmin.get_text()
        Xmin=Xmin.replace('\\','@')
        Xmax=self.entryXmax.get_text()
        Xmax=Xmax.replace('\\','@')
        Ymin=self.entryYmin.get_text()
        Ymin=Ymin.replace('\\','@')
        Ymax=self.entryYmax.get_text()
        Ymax=Ymax.replace('\\','@')
        Ux=self.entryUx.get_text()
        Ux=Ux.replace('\\','@')
        Hauteur=self.entryHauteur.get_text()
        Hauteur=Hauteur.replace('\\','@')

        Texte_Code=Texte_Code+Xmin+","+Xmax+","+Ymin+","+Ymax+",\n"
        Texte_Code=Texte_Code+Ux+",1,1,\n"
        Texte_Code=Texte_Code+Hauteur+",\n"
        Texte_Code=Texte_Code+"// ----------------- début des options\n"
        Texte_Code=Texte_Code+"[\n"
        Options=self.traiter_options()
        Texte_Code=Texte_Code+Options
        Texte_Code=Texte_Code+"]\n"
        Texte_Code=Texte_Code+"// ----------------- fin des options\n"
        Texte_Code=Texte_Code+"\\end{pro-courbesemilog}"
        ecrire_texte_textview(Texte_Code,text_view)




    #-------------------------------------------------------------
    # Mise à jour après des changements dans la définition
    #-------------------------------------------------------------      
            
        
    def on_entryXmin_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryXmax_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryYmin_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryYmax_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False 

        
    def on_entryHauteur_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False 
        
    def on_checkbuttonTexteLibre_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonTexteLibre.get_active()==True:
            self.TL.windowTL.show_all()
        else:
            self.TL.windowTL.hide()
        self.Etat_Compilation=False
        
    def on_checkbuttonPointLibre_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonPointLibre.get_active()==True:
            self.PL.windowPL.show_all()
        else:
            self.PL.windowPL.hide()
        self.Etat_Compilation=False

        
    def on_checkbuttonF2_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonF2.get_active()==True:
            self.F2.checkbuttonActiver.set_active(True)
            self.F2.windowF.show_all()
        else:
            self.F2.checkbuttonActiver.set_active(False)
            self.F2.windowF.hide()
        self.Etat_Compilation=False
            
    def on_checkbuttonF3_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonF3.get_active()==True:
            self.F3.checkbuttonActiver.set_active(True)
            self.F3.windowF.show_all()
        else:
            self.F3.checkbuttonActiver.set_active(False)
            self.F3.windowF.hide()
        self.Etat_Compilation=False 
        
    def on_checkbuttonF4_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonF4.get_active()==True:
            self.F4.checkbuttonActiver.set_active(True)
            self.F4.windowF.show_all()
        else:
            self.F4.checkbuttonActiver.set_active(False)
            self.F4.windowF.hide()
        self.Etat_Compilation=False

    #-------------------------------------------------------------
    # Mise à jour du label du nom de paquet à utiliser
    #-------------------------------------------------------------          
    def on_radiobuttonMetapost_clicked(self,widget):
        self.labelEntete.set_label("Placer dans l\'entête : \\usepackage[xcas]{pro-courbes}")
        self.Etat_Compilation=False
        
    def on_radiobuttonAsymptote_clicked(self,widget):
        self.labelEntete.set_label("Placer dans l\'entête : \\usepackage[xcas]{pro-asy-courbes}")       
        self.Etat_Compilation=False
        

    #-------------------------------------------------------------
    # Traitement des options    
    #-------------------------------------------------------------  
    def traiter_options(self):
        Options=""
        if self.checkbuttonTitreGauche.get_active()==True :
           Options="[\"titre-gauche\",\""
           TitreGauche=self.entryTitreGauche.get_text()
           TitreGauche=traiter_texte(TitreGauche)
           Options=Options+TitreGauche
           Options=Options+"\"],\n"
           
        if self.checkbuttonTitreCentre.get_active()==True :
           Options=Options+"[\"titre-centre\",\""
           TitreCentre=self.entryTitreCentre.get_text()
           TitreCentre=traiter_texte(TitreCentre)
           Options=Options+TitreCentre
           Options=Options+"\"],\n" 
           
        if self.checkbuttonTitreDroite.get_active()==True :
           Options=Options+"[\"titre-droite\",\""
           TitreDroite=self.entryTitreDroite.get_text()
           TitreDroite=traiter_texte(TitreDroite)
           Options=Options+TitreGauche
    

        Options=Options+self.PL.Texte_Point_Libre
        Options=Options+self.TL.Texte_Libre
        Texte_Code=self.F1.Texte_Options
        if self.F2.checkbuttonActiver.get_active()==True:
            Texte_Code=Texte_Code+self.F2.Texte_Options
        if self.F3.checkbuttonActiver.get_active()==True:
            Texte_Code=Texte_Code+self.F3.Texte_Options
        if self.F4.checkbuttonActiver.get_active()==True:
            Texte_Code=Texte_Code+self.F4.Texte_Options 
        Options=Options+Texte_Code  
        Options=Options+"[\"rien\"]\n"
        return Options

    #-------------------------------------------------------------
    # Mise à jour suite au traitement des options   
    #-------------------------------------------------------------          
    def on_checkbuttonTitreGauche_clicked(self,widget):
        if self.checkbuttonTitreGauche.get_active()==False :
            self.entryTitreGauche.set_sensitive(False)
        else :
            self.entryTitreGauche.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False

    def on_checkbuttonTitreCentre_clicked(self,widget):
        if self.checkbuttonTitreCentre.get_active()==False :
            self.entryTitreCentre.set_sensitive(False)
        else :
            self.entryTitreCentre.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False
            
    def on_checkbuttonTitreDroite_clicked(self,widget):
        if self.checkbuttonTitreDroite.get_active()==False :
            self.entryTitreDroite.set_sensitive(False)
        else :
            self.entryTitreDroite.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False
        
    def on_entryTitreGauche_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False

    def on_entryTitreCentre_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False 

    def on_entryTitreDroite_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False


    #-------------------------------------------------------------
    # lancement de la compilation   
    #-------------------------------------------------------------  
    def on_buttonTester_pressed(self,widget):
        self.progressbar.set_text("en cours...")
        
    def on_buttonTester_released(self,widget):
        # création du fichier codeprofessor à partir du buffer
        text_buffer=self.textviewCodeProfessor.get_buffer()
        start_iter = text_buffer.get_start_iter()
        end_iter = text_buffer.get_end_iter()
        Texte=text_buffer.get_text(start_iter, end_iter, include_hidden_chars=True)
        ecrire_codeprofessor(Texte)
        # création du fichier codesupp à partir du buffer
        text_buffer=self.textviewSupp.get_buffer()
        start_iter = text_buffer.get_start_iter()
        end_iter = text_buffer.get_end_iter()
        Texte=text_buffer.get_text(start_iter, end_iter, include_hidden_chars=True)
        ecrire_codesupp(Texte)  
        if self.radiobuttonMetapost.get_active()==True:
            ecrire_enteteprofessor("\\usepackage[xcas]{pro-courbes}")   
            compiler("mp")
            self.Etat_Compilation=True
            afficher("mp","courbesemilog1")
        else:
            ecrire_enteteprofessor("\\usepackage[xcas]{pro-asy-courbes}")   
            compiler("asy")
            self.Etat_Compilation=True
            afficher("asy","courbesemilog1")
        self.progressbar.set_text("")
        
            
    #-------------------------------------------------------------
    # Affichage du code graphique   
    #-------------------------------------------------------------  
    def on_buttonCodeGraphique_clicked(self,widget):
        if self.radiobuttonMetapost.get_active()==True: 
            afficher_codegraphique("mp","courbesemilog1",self.Etat_Compilation)
        else:
            afficher_codegraphique("asy","courbesemilog1",self.Etat_Compilation)

    #-------------------------------------------------------------
    # Affichage de l'image  
    #-------------------------------------------------------------  
    def on_buttonPdf_clicked(self,widget):
        if self.radiobuttonMetapost.get_active()==True: 
            afficher_imagepng("mp","courbesemilog1",self.Etat_Compilation)
        else:
            afficher_imagepng("asy","courbesemilog1",self.Etat_Compilation)         


            
#-------------------------------------------------------------          
#-------------------------------------------------------------      
# Boucle principale
#-------------------------------------------------------------
#-------------------------------------------------------------
if __name__ == "__main__":
    Courbesemilog()
    gtk.main()

